package cn.iocoder.yudao.module.system.dal.mysql.yk;


import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.system.controller.admin.yk.vo.YkElderlyDeliveryHistoryPageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.yk.vo.YkElderlyDeliveryHistoryRespVO;
import cn.iocoder.yudao.module.system.dal.dataobject.yk.YkElderlyDeliveryDO;

import org.apache.ibatis.annotations.Mapper;

import java.time.LocalDate;
import java.util.List;
import java.util.Map;


/**
 * 长者送餐中心 Mapper
 *
 * @author 系统管理员
 */
@Mapper
public interface YkElderlyDeliveryMapper extends BaseMapperX<YkElderlyDeliveryDO> {

    default PageResult<YkElderlyDeliveryDO> selectPage(YkElderlyDeliveryHistoryPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<YkElderlyDeliveryDO>()
                .eqIfPresent(YkElderlyDeliveryDO::getMealType, reqVO.getMealType())
                .eqIfPresent(YkElderlyDeliveryDO::getStatus, reqVO.getStatus())
                .likeIfPresent(YkElderlyDeliveryDO::getYkElderName, reqVO.getElderName())
                .betweenIfPresent(YkElderlyDeliveryDO::getDeliveryDate, reqVO.getDeliveryDate())
                .inIfPresent(YkElderlyDeliveryDO::getTenantId,reqVO.getTenantIds())
                .orderByDesc(YkElderlyDeliveryDO::getId));
    }

    List<Map<String, Object>> selectDeliveryStatsByStaffMap(LocalDate startDate, LocalDate endDate, Long staffId);
}